Unit DLLSample_;

Interface

Uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, ExtCtrls, Menus, ExtDlgs;

Type
    TForm1 = Class(TForm)
        SaveDialog1: TSaveDialog;
        OpenDialog1: TOpenDialog;
        PopupMenu1: TPopupMenu;
        Image1: TImage;
        LoadBitmap1: TMenuItem;
        LoadBitmapShape1: TMenuItem;
        SaveBitmapShape1: TMenuItem;
        ETC: TMenuItem;
        ResetWindowShape1: TMenuItem;
        N1: TMenuItem;
        N2: TMenuItem;
        OpenPictureDialog1: TOpenPictureDialog;
        Procedure FormCreate(Sender: TObject);
        Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
        Procedure LoadBitmap1Click(Sender: TObject);
        Procedure LoadBitmapShape1Click(Sender: TObject);
        Procedure SaveBitmapShape1Click(Sender: TObject);
        Procedure ResetWindowShape1Click(Sender: TObject);
        Procedure ETCClick(Sender: TObject);
        Procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
    PRIVATE
    { Private declarations }
    PUBLIC
    { Public declarations }
    End;

Var
    Form1: TForm1;

Implementation

{$R *.DFM}

Uses ShpModuleUnit;

Procedure TForm1.FormCreate(Sender: TObject);
Begin
    If Not LoadDll Then ShowMessage('Cannot load dll module !');
    If Not SetWindowShapeFromBitmap(Handle, Image1.Picture.Bitmap.Handle, clWhite, ETC.Checked, 100) Then
        ShowMessage('Cannot Set Window Shape From Bitmap');
End;

Procedure TForm1.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
    If Not ReleaseDLL Then ShowMessage('Cannot release dll module !');
End;

Procedure TForm1.LoadBitmap1Click(Sender: TObject);
Begin
    If OpenPictureDialog1.Execute Then Begin
        Image1.Picture.LoadFromFile(OpenPictureDialog1.Filename);
        If Not SetWindowShapeFromBitmap(Handle, Image1.Picture.Bitmap.Handle, clWhite, ETC.Checked, 100) Then
            ShowMessage('Cannot Load Bitmap');
    End;
End;

Procedure TForm1.LoadBitmapShape1Click(Sender: TObject);
Begin
    If OpenDialog1.Execute Then
        If Not LoadWindowShape(PChar(OpenDialog1.Filename), Handle, 100) Then ShowMessage('Cannot load shape data');
End;

Procedure TForm1.SaveBitmapShape1Click(Sender: TObject);
Begin
    If SaveDialog1.Execute Then
        If Not SaveWindowShapeFromBitmap(PChar(SaveDialog1.Filename), Image1.Picture.Bitmap.Handle, clWhite, ETC.Checked) Then ShowMessage('Cannot save shape data');
End;

Procedure TForm1.ResetWindowShape1Click(Sender: TObject);
Begin
    ResetWindowShape(Handle);
End;

Procedure TForm1.ETCClick(Sender: TObject);
Begin
    ETC.Checked := Not ETC.Checked;
End;

Procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Const
    SC_DragMove = $F012;
Begin
    ReleaseCapture;
    Perform(WM_SYSCOMMAND, SC_DragMove, 0);
End;

End.

